clear all; close all; clc;
output_folder = 'C:\Users\Tej\Desktop\Icepod\DICE\Matlab\Chirp\';
ref_matfile_name = 'RefSignalsIdeal';
refsig1 = 'Ref3usIdeal';
refsig2 = 'Ref1usIdeal';
waveType0 = 'IQ-0dB3us';
waveType1 = 'IQ-0dB1us';
f_c = 38e6;
bw = 60e6;
fs = 150e6;
pw1 = 3e-6;
pw2 = 1e-6;
f_dot1 = bw./pw1;
f_dot2 = bw./pw2;
f_min = f_c - bw/2;
f_max = f_c + bw/2;
phi = 0;
t1 = 0:1/fs:pw1-1/fs;
t2 = 0:1/fs:pw2-1/fs;
% Pulse tapers for Reference Function
tapertype='tukey';                 % What taper (if any) to use on the reference function ('tukey', 'cheb', 'both', or 'none')
taperparam=.5;                     % Adjustable parameter to go with the taper.  Meaning varies by taper type.  For 'both', the first element is for tukey and the second is for chebyshev
A1 = 32700/sqrt(1);     % sIGNAL AMPLITUDE Channel A pulse 1
B1 = 32700/sqrt(1);     % sIGNAL AMPLITUDE Channel B pulse 2
A2 = 32700/sqrt(1);
B2 = 32700/sqrt(1);
phi1A0 = 0;      % Channel A 1o us pulse
phi2A0 = 0;
phi1B0 = 0;
phi2B0 = 0;
phi1A = phi1A0 + 2*pi*(f_min*t1 + f_dot1/2*t1.^2);
phi2A = phi2A0 + 2*pi*(f_min*t2 + f_dot2/2*t2.^2);
phi1B = phi1B0 + 2*pi*(f_min*t1 + f_dot1/2*t1.^2);
phi2B = phi2B0 + 2*pi*(f_min*t2 + f_dot2/2*t2.^2);
% Tx1_IF = A/sqrt(2)*cos(2*pi*(f_min + f_dot1/2*t1).*t1 + phi) + A/sqrt(2)*sin(2*pi*(f_min + f_dot1/2*t1).*t1 + phi);% - A/2*sin(2*pi*(f_min + f_dot1/2*t1).*t1 + phi);
% Tx2_IF = A/sqrt(2)*cos(2*pi*(f_min + f_dot2/2*t2).*t2 + phi) + A/sqrt(2)*sin(2*pi*(f_min + f_dot2/2*t2).*t2 + phi);%-A/2*sin(2*pi*(f_min + f_dot2/2*t2).*t2 + phi);

% I1 = A*cos(2*pi*(f_min + f_dot1/2*t1).*t1 + phi);%A*cos(2*pi*f_c*t1 + phi);
% Q1 = A*sin(2*pi*(f_min + f_dot1/2*t1).*t1 + phi);%A*sin(2*pi*f_c*t1 + phi);
% I2 = cos(2*pi*f_c*t2 + phi);
% Q2 = sin(2*pi*f_c*t2 + phi);

IA1 = A1/sqrt(2)*cos(phi1A);
QA1 = -A1/sqrt(2)*sin(phi1A);
IB1 = B1/sqrt(2)*cos(phi1B);
QB1 = -B1/sqrt(2)*sin(phi1B);

IA2 = A2/sqrt(2)*cos(phi2A);
QA2 = -A2/sqrt(2)*sin(phi2A);
IB2 = B2/sqrt(2)*cos(phi2B);
QB2 = -B2/sqrt(2)*sin(phi2B);


A_Out1 = IA1 + QA1;
A_Out2 = IB2 + QB2;
B_Out1 = IB1 + QB1;
B_Out2 = IB2 + QB2;

% A_Out1 = IA1*sqrt(2);
% A_Out2 = IB2*sqrt(2);
% B_Out1 = IB1*sqrt(2);
% B_Out2 = IB2*sqrt(2);

Nref1us = length(A_Out2);
Nref10us = length(A_Out1);

if strcmp(tapertype,'tukey')
    A_Out1 = int16(floor(A_Out1.*tukeywin(Nref10us,taperparam)'));
    B_Out1 = int16(floor(B_Out1.*tukeywin(Nref10us,taperparam)'));
    A_Out2 = int16(floor(A_Out2.*tukeywin(Nref1us,taperparam)'));
    B_Out2 = int16(floor(B_Out2.*tukeywin(Nref1us,taperparam)'));
elseif strcmp(tapertype,'cheb')
    A_Out1 = int16(floor(A_Out1.*chebwin(Nref10us,taperparam(2))'));
    B_Out1 = int16(floor(B_Out1.*chebwin(Nref10us,taperparam(2))'));
    A_Out2 = int16(floor(A_Out2.*chebwin(Nref1us,taperparam(2))'));
    B_Out2 = int16(floor(B_Out2.*chebwin(Nref1us,taperparam(2))'));
    
elseif strcmp(tapertype,'both')
    A_Out1 = int16(floor(A_Out1'.*tukeywin(Nref10us,taperparam(1)).*chebwin(Nref10us,taperparam(2))))';
    B_Out1 = int16(floor(B_Out1'.*tukeywin(Nref10us,taperparam(1)).*chebwin(Nref10us,taperparam(2))))';
    A_Out2 = int16(floor(A_Out2'.*tukeywin(Nref1us,taperparam(1)).*chebwin(Nref1us,taperparam(2))))';
    B_Out2 = int16(floor(B_Out2'.*tukeywin(Nref1us,taperparam(1)).*chebwin(Nref1us,taperparam(2))))';
    
elseif strcmp(tapertype,'none')==0
    error('Parameter "tapertype" must be a string equal to "tukey", "cheb", "both", or "none".')
end

% fsrf = 2100e6;
% AoutRf1 = resample(double(A_Out1),fsrf,fs);
% NFFTRF = 2^nextpow2(length(AoutRf1));
% fifrf = fsrf/2*linspace(0,1,NFFTRF/2+1);
% F_RF_A_Out1 = 2*abs(fft(double(AoutRf1),NFFTRF))/NFFTRF;

% figure
% plot(fifrf/1e6,10*log10(F_RF_A_Out1(1:NFFTRF/2+1)))
% title('Amplitude Spectrum of RF 10us Sig Channel A')
% xlabel('Frequency (MHz)')
% ylabel('|F_Tx_IF| (dB)')
% grid on
%
% AoutRf_filt = dicerffilter_2gs(double(AoutRf1));
%
% F_RF_A_Out_filt = 2*abs(fft(AoutRf_filt,NFFTRF))/NFFTRF;
% figure
% plot(fifrf/1e6,10*log10(F_RF_A_Out_filt(1:NFFTRF/2+1)))
% title('Amplitude Spectrum of RF 10us Sig Channel A')
% xlabel('Frequency (MHz)')
% ylabel('|F_Tx_IF| (dB)')
% grid on

% A_Out1 = int16(floor(dicebbfilt(A_Out1)));
% % B_Out1 = int16(floor(dicebbfilt(B_Out1)));
% A_Out2 = int16(floor(dicebbfilt(A_Out2)));
% B_Out2 = int16(floor(dicebbfilt(B_Out2)));

L = length(A_Out1);
NFFT = 2^nextpow2(L);   % Next power of 2 from length of y
F_A_Out1 = 2*abs(fft(double(A_Out1),NFFT))/L;
F_B_Out1 = 2*abs(fft(double(B_Out1),NFFT))/L;
fif = fs/2*linspace(0,1,NFFT/2+1);

figure
subplot 211
plot(fif/1e6,10*log10(F_A_Out1(1:NFFT/2+1)))
title('Amplitude Spectrum of IF 10us Sig Channel A')
xlabel('Frequency (MHz)')
ylabel('|F_Tx_IF| (dB)')
grid on

subplot 212
plot(fif/1e6,10*log10(F_B_Out1(1:NFFT/2+1)))
title('Amplitude Spectrum of IF 10us Sig Channel B')
xlabel('Frequency (MHz)')
ylabel('|F_Tx_IF| (dB)')
grid on

% figure
% spectrogram(double(Tx1_IF),256,128,256,fs,'yaxis')
% title('Spectrogram of IF')

L = length(A_Out2);
NFFT = 2^nextpow2(L);   % Next power of 2 from length of y
F_A_Out2 = 2*abs(fft(double(A_Out2),NFFT))/L;
F_B_Out2 = 2*abs(fft(double(B_Out2),NFFT))/L;
fif = fs/2*linspace(0,1,NFFT/2+1);

figure
subplot 211
plot(fif/1e6,10*log10(F_A_Out2(1:NFFT/2+1)))
title('Amplitude Spectrum of IF 1us Sig Channel A')
xlabel('Frequency (MHz)')
ylabel('|F_Tx_IF| (dB)')
grid on
subplot 212
plot(fif/1e6,10*log10(F_B_Out2(1:NFFT/2+1)))
title('Amplitude Spectrum of IF 1us Sig Channel B')
xlabel('Frequency (MHz)')
ylabel('|F_Tx_IF| (dB)')
grid on

figure
subplot 211
plot(t1*1e6,A_Out1)
title('10us Signal Channel A')
xlabel('Time \muS')
subplot 212
plot(t1*1e6,B_Out1)
title('10us Signal Channel B')
xlabel('Time \muS')

figure
subplot 211
plot(t2*1e6,A_Out2)
title('1us Signal Channel A')
xlabel('Time \muS')
subplot 212
plot(t2*1e6,B_Out2)
title('1us Signal Channel B')
xlabel('Time \muS')

% figure
% spectrogram(Tx2_IF,256,128,256,fs,'yaxis')
% title('Spectrogram of IF')
% file sizes need to be multiple of 128 bytes
fid = fopen([output_folder,'wave0.',tapertype,num2str(taperparam),waveType0,'.bin'], 'w');
for i= 1:length(A_Out1)
    fwrite(fid,A_Out1(i),'int16');
    fwrite(fid,B_Out1(i),'int16');
end
if(mod(length(A_Out1)*4,128))
    for i = 1:((128- mod(length(A_Out1)*4,128))/4)
        fwrite(fid,0,'int32');
    end
end
disp(sprintf('Number of samples for %gus pulse is %d \n',pw1*1e6,length(A_Out1)+i));
disp(sprintf('File padded with %d, 0 amplitude samples\n',i));
fclose(fid);


fid = fopen([output_folder,'wave1.',tapertype,num2str(taperparam),waveType1,'.bin'], 'w');
for i= 1:length(A_Out2)
    fwrite(fid,A_Out2(i),'int16');
    fwrite(fid,B_Out2(i),'int16');
end
if(mod(length(A_Out2)*4,128))
    for i = 1:((128- mod(length(A_Out2)*4,128))/4)
        fwrite(fid,0,'int32');
    end
end
disp(sprintf('Number of samples for %gus pulse is %d',pw2*1e6,length(A_Out2)+i));
disp(sprintf('File padded with %d, 0 amplitude samples\n',i));
fclose(fid);
disp(sprintf('Use Nco Frequecny = %g MHz upchirp or %g MHz downchirp',(188e6-f_c)/1e6, (188e6 + f_c)/1e6));

%% Write referencesignal files for realtime display
% References signals are tapered to reduce sidelobes
% Apply taper to reference signal:
sig10usref = double(A_Out1');
sig1usref = double(A_Out2');
Nref1us = length(sig1usref);
Nref10us = length(sig10usref);
if strcmp(tapertype,'tukey')
    sig1usref = sig1usref.*tukeywin(Nref1us,taperparam);
    sig10usref = sig10usref.*tukeywin(Nref10us,taperparam);
elseif strcmp(tapertype,'cheb')
    sig1usref = sig1usref.*chebwin(Nref1us,taperparam(2));
    sig10usref = sig10usref.*chebwin(Nref10us,taperparam(2));
elseif strcmp(tapertype,'both')
    sig1usref = sig1usref.*tukeywin(Nref1us,taperparam(1)).*chebwin(Nref1us,taperparam(2));
    sig10usref = sig10usref.*tukeywin(Nref10us,taperparam(1)).*chebwin(Nref10us,taperparam(2));
elseif strcmp(tapertype,'none')==0
    error('Parameter "tapertype" must be a string equal to "tukey", "cheb", "both", or "none".')
end
fidref1 = fopen([output_folder,refsig1,'-',tapertype,num2str(taperparam),waveType0,'.bin'],'w');
for i= 1:Nref10us
    fwrite(fidref1,sig10usref(i),'float64','b');
end
fclose(fidref1);
fidref2 = fopen([output_folder,refsig2,'-',tapertype,num2str(taperparam),waveType1,'.bin'],'w');
for i = 1:Nref1us
    fwrite(fidref2,sig1usref(i),'float64','b');
end
fclose(fidref2);
figure
subplot 211
plot(t1*1e6,sig10usref)
title({'10\mus Reference Signal';['taper type: ',tapertype, '; taper: ',num2str(taperparam)]})
xlabel('Time \mus')

subplot 212
plot(t2*1e6,sig1usref)
title({'1\mus Reference Signal';['taper type: ',tapertype, '; taper: ',num2str(taperparam)]})
xlabel('Time \mus')



%% Reference signals for post processing
sig10usref = double(A_Out1');
sig1usref = double(A_Out2');
%%save([output_folder,ref_matfile_name],'sig10usref','sig1usref');

