% This loads the Rx signals from mat files generated by DicefakeData*us.m
% code and adds noise specified by noiseAmplitude for each signal. 
% Dice Data files are created at target location. 
% Each file is about 90 MB and this writes 600 files for every hour of
% data. 
% 03/01/2016- file name modified to match new format

clc; clear all; close all;
load rxDat10us
load rxDat1us
StartFrame = [933 258]';
StopFrame = [421 770]';
numFramesInFile = 975; 
numFiles = 100;        
for n = 1:numFiles;
    fid1 = fopen(['F:\Dice Simulation\AN02_F1003_20151127_',num2str(mod(floor((n-1)*10/3600),24),'%02d'),...
        num2str(mod(floor((n-1)*10/60),60),'%02d'),...
        num2str(mod((n-1)*10,60),'%02d'),'_',num2str(n,'%04d'),'.rad'],'w');
    fprintf('Writing file %d of %d\n',n,numFiles)
     % New random noise of specified amplitude is added to each received
     % echo before it is written to the data file. 
    for i = 1:numFramesInFile;
        fwrite(fid1,StartFrame,'int16');
        fwrite(fid1,int16(round(RxIF10us + randn(size(RxIF10us))*noiseAmplitude10us)),'int16');
        fwrite(fid1,zeros(8,1),'int32');
        fwrite(fid1,StopFrame,'int16');
        fwrite(fid1,StartFrame,'int16');
        fwrite(fid1,int16(round(RxIF10us + randn(size(RxIF10us))*noiseAmplitude10us)),'int16');
        fwrite(fid1,zeros(8,1),'int32');
        fwrite(fid1,StopFrame,'int16');
        fwrite(fid1,StartFrame,'int16');
        fwrite(fid1,int16(round(RxIF1us + randn(size(RxIF1us))*noiseAmplitude1us)),'int16');
        fwrite(fid1,zeros(8,1),'int32');
        fwrite(fid1,StopFrame,'int16');
        fwrite(fid1,StartFrame,'int16');
        fwrite(fid1,int16(round(RxIF1us + randn(size(RxIF1us))*noiseAmplitude1us)),'int16');
        fwrite(fid1,zeros(8,1),'int32');
        fwrite(fid1,StopFrame,'int16');
    end
    fclose(fid1);
end